/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.kaki.client.gui;

import java.awt.BorderLayout;
import java.math.BigDecimal;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.kaki.client.metier.EOPafImportAdix;
import org.cocktail.kaki.common.KakiConstantes;
import org.cocktail.kaki.common.KakiIcones;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class AdixImportView extends javax.swing.JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 5437110486180297751L;
	protected EODisplayGroup eodImportAdix;
	protected ZEOTable myEOTableImportAdix;
	protected ZEOTableModel myTableModelImportAdix;
	protected TableSorter myTableSorterImportAdix;


    /** Creates new form TemplateJPanel */
    public AdixImportView(EODisplayGroup dgImportAdix) {

    	eodImportAdix = dgImportAdix;
    	
        initComponents();

        initGui();
        
    }


	/** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewTable = new javax.swing.JPanel();
        btnImporter = new javax.swing.JButton();
        jLabel11 = new javax.swing.JLabel();
        tfFile = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        checkEntete = new javax.swing.JCheckBox();
        btnGetFile = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();

        viewTable.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        viewTable.setLayout(new java.awt.BorderLayout());

        btnImporter.setText("Importer");
        btnImporter.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnImporterActionPerformed(evt);
            }
        });

        jLabel11.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel11.setText("FICHIER :");

        tfFile.setEditable(false);
        tfFile.setEnabled(false);

        jLabel1.setFont(new java.awt.Font("Tahoma", 0, 10));
        jLabel1.setForeground(new java.awt.Color(102, 102, 102));
        jLabel1.setText("* Sélectionnez un fichier puis cliquez sur le bouton pour l'importer");

        checkEntete.setForeground(new java.awt.Color(102, 102, 102));
        checkEntete.setText("Fichier Avec Entête");
        checkEntete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkEnteteActionPerformed(evt);
            }
        });

        btnGetFile.setToolTipText("Sélection du fichier à importer");
        btnGetFile.setMaximumSize(new java.awt.Dimension(75, 75));
        btnGetFile.setMinimumSize(new java.awt.Dimension(30, 22));
        btnGetFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnGetFileActionPerformed(evt);
            }
        });

        jLabel2.setText("Détail de l'import pour la période sélectionnée :");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 829, Short.MAX_VALUE)
                        .addContainerGap())
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(btnImporter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 133, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())
                    .add(layout.createSequentialGroup()
                        .add(jLabel11, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 102, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 386, Short.MAX_VALUE)
                            .add(layout.createSequentialGroup()
                                .add(tfFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 324, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(btnGetFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 33, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                        .add(31, 31, 31)
                        .add(checkEntete)
                        .add(195, 195, 195))
                    .add(layout.createSequentialGroup()
                        .add(jLabel2)
                        .addContainerGap(615, Short.MAX_VALUE))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel11)
                            .add(tfFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(btnGetFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel1))
                    .add(checkEntete))
                .add(18, 18, 18)
                .add(jLabel2)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 385, Short.MAX_VALUE)
                .add(18, 18, 18)
                .add(btnImporter)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btnImporterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnImporterActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_btnImporterActionPerformed

    private void checkEnteteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkEnteteActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_checkEnteteActionPerformed

    private void btnGetFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnGetFileActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_btnGetFileActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JButton btnGetFile;
    private javax.swing.JButton btnImporter;
    private javax.swing.JCheckBox checkEntete;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextField tfFile;
    private javax.swing.JPanel viewTable;
    // End of variables declaration//GEN-END:variables

    
    
    
    private void initGui() {
    	                
    	btnGetFile.setIcon(KakiIcones.ICON_SELECT_16);
        btnImporter.setIcon(KakiIcones.ICON_PARAMS_16);
        
		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

    	ZEOTableModelColumn	col = new ZEOTableModelColumn(eodImportAdix, EOPafImportAdix.FOURNISSEUR_KEY, "Fournisseur", 75);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodImportAdix, EOPafImportAdix.NO_INSEE_KEY, "SECU", 50);
    	col.setAlignment(SwingConstants.CENTER);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodImportAdix, EOPafImportAdix.MONTANT_KEY, "Montant", 75);
    	col.setColumnClass(BigDecimal.class);
    	col.setAlignment(SwingConstants.RIGHT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodImportAdix, EOPafImportAdix.PCO_NUM_KEY, "Imputation", 50);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodImportAdix, EOPafImportAdix.PCO_NUM_CONTREPARTIE_KEY, "Ventilation", 30);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodImportAdix, EOPafImportAdix.UB_KEY, "UB", 50);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodImportAdix, EOPafImportAdix.CR_KEY, "CR", 50);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodImportAdix, EOPafImportAdix.SOUS_CR_KEY, "SOUS CR", 50);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodImportAdix, EOPafImportAdix.LOLF_CODE_KEY, "LOLF", 50);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);


		myTableModelImportAdix = new ZEOTableModel(eodImportAdix, myCols);
		myTableSorterImportAdix = new TableSorter(myTableModelImportAdix);

		myEOTableImportAdix= new ZEOTable(myTableSorterImportAdix);
		//myEOTable.addListener(myListenerContrat);
		myTableSorterImportAdix.setTableHeader(myEOTableImportAdix.getTableHeader());		

		myEOTableImportAdix.setBackground(KakiConstantes.COLOR_FOND_NOMENCLATURES);
		myEOTableImportAdix.setSelectionBackground(KakiConstantes.COLOR_SELECTED_ROW);
		myEOTableImportAdix.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTable.setLayout(new BorderLayout());
		viewTable.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTable.removeAll();
		viewTable.add(new JScrollPane(myEOTableImportAdix), BorderLayout.CENTER);

		
    }


	public ZEOTable getMyEOTableImportAdix() {
		return myEOTableImportAdix;
	}


	public void setMyEOTableImportAdix(ZEOTable myEOTableImportAdix) {
		this.myEOTableImportAdix = myEOTableImportAdix;
	}


	public javax.swing.JButton getBtnGetFile() {
		return btnGetFile;
	}


	public void setBtnGetFile(javax.swing.JButton btnGetFile) {
		this.btnGetFile = btnGetFile;
	}


	public javax.swing.JButton getBtnImporter() {
		return btnImporter;
	}


	public void setBtnImporter(javax.swing.JButton btnImporter) {
		this.btnImporter = btnImporter;
	}


	public javax.swing.JCheckBox getCheckEntete() {
		return checkEntete;
	}


	public void setCheckEntete(javax.swing.JCheckBox checkEntete) {
		this.checkEntete = checkEntete;
	}


	public javax.swing.JTextField getTfFile() {
		return tfFile;
	}


	public void setTfFile(javax.swing.JTextField tfFile) {
		this.tfFile = tfFile;
	}


	public javax.swing.JPanel getViewTable() {
		return viewTable;
	}


	public void setViewTable(javax.swing.JPanel viewTable) {
		this.viewTable = viewTable;
	}    
    

}
